<template>
  <div class="absolute inset-x-0 top-20">
    <div class="flex justify-center">
      <div class="input-group flex items-stretch w-11/12">
        <input
          type="search"
          class="form-control inline-block flex-auto min-w-0 block px-3 py-1.5 text-base font-normal text-gray-700 bg-white bg-clip-padding border border-solid border-gray-300 rounded transition ease-in-out m-0 focus:text-gray-700 focus:bg-white focus:border-orange-book focus:outline-none"
          placeholder="Rechercher"
          aria-label="Search"
          aria-describedby="button-addon2"
          v-model="search"
          v-on:keyup.enter="searcher()"
        />
        <button
          @click="searcher()"
          class="btn inline-block px-6 py-2.5 bg-orange-book text-white font-medium text-xs leading-tight uppercase rounded shadow-md hover:bg-orange-book-hover hover:shadow-lg focus:bg-orange-book-hover focus:shadow-lg focus:outline-none focus:ring-0 active:bg-orange-book-hover active:shadow-lg transition duration-150 ease-in-out flex items-center"
          type="button"
          id="button-addon2"
        >
          <svg
            aria-hidden="true"
            focusable="false"
            data-prefix="fas"
            data-icon="search"
            class="w-4"
            role="img"
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 512 512"
          >
            <path
              fill="currentColor"
              d="M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z"
            ></path>
          </svg>
        </button>
      </div>
    </div>

    <!--<Books :booksToSearch="mySearch" />-->

    <div
      class="p-10 grid grid-cols-2 sm:grid-cols-3 md:grid-cols-4 lg:grid-cols-6 xl:grid-cols-7 gap-4 content-center"
    >
      <Book v-for="book in books" v-bind:key="book.id" :book="book" />
    </div>
  </div>
</template>

<script>
import Book from "../components/Book";
import { searchABookByTitle } from "./../services/bookService";

export default {
  name: "Search",
  data() {
    return {
      search: "",
      mySearch: "",
      books: [],
    };
  },
  components: {
    Book,
  },

  methods: {
    async searcher() {
      // Reinitialise la liste des livres
      this.books = [];
      const result = await searchABookByTitle(this.search, 0);
      // Evite d'afficher des doublons, ou des livres pas sortis
      result.items.forEach((book) => {
        if (book.volumeInfo.readingModes.text) {
          this.books.push(book);
        }
      });
    },
  },
};
</script>
